package com.tzy.system.service;

import com.tzy.common.core.domain.entity.SysDictData;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 字典 业务层
 * 
 * @author zheng
 */
public interface ISysDictDataService
{
    /**
     * 根据条件分页查询字典数据
     * 
     * @param dictData 字典数据信息
     * @return 字典数据集合信息
     */
    public List<SysDictData> selectDictDataList(SysDictData dictData);

    /**
     * 根据字典类型和字典键值查询字典数据信息
     * 
     * @param dictType 字典类型
     * @param dictValue 字典键值
     * @return 字典标签
     */
    public String selectDictLabel(String dictType, String dictValue);

    /**
     * 根据字典数据ID查询信息
     * 
     * @param dictCode 字典数据ID
     * @return 字典数据
     */
    public SysDictData selectDictDataById(Long dictCode);

    /**
     * 批量删除字典数据
     * 
     * @param ids 需要删除的数据
     * @return 结果
     */
    public int deleteDictDataByIds(String ids);

    /**
     * 删除字典数据
     * 
     * @param dictCode 需要删除的数据
     * @return 结果
     */
    public int deleteDictDataById(String dictCode);
    /**
     * 新增保存字典数据信息
     * 
     * @param dictData 字典数据信息
     * @return 结果
     */
    public int insertDictData(SysDictData dictData);

    /**
     * 修改保存字典数据信息
     * 
     * @param dictData 字典数据信息
     * @return 结果
     */
    public int updateDictData(SysDictData dictData);
    /**
     * 查询指定表指定字段
     */
    public String selectDictLabels(String table, String dicText , String dicCode, String key);

	List<SysDictData> getByTypeAndStatus(String dictType, String status);

    Boolean checkValueByTypeAndStatus(String type, String value, String status);

    List<String> getPayTypeByPoint( Integer point);

    /**
     * 根据类型查询字典表数据,提供redis缓存,
     * @param dictType
     * @param dictLabel
     * @param status
     * @return
     */
    List<SysDictData> selectDictDataByType(@NotNull String dictType, String dictLabel, String status);

    List<SysDictData> selectDictDataByCache(@NotNull String dictType, String dictLabel, String status,boolean hasCache);

    String selectOneDictDataValueByLabel(@NotNull String dictType, @NotNull String dictLabel);

    String getMerchantPointMsg(@NotNull String type);

    SysDictData groupActs();

    List<SysDictData> selectDictDataByCache(@NotNull String dictType, boolean hasCache);

    List<SysDictData> selectDictDataByCacheV2(@NotNull String dictType, String dictLabel, String status, boolean userCache);
}
